#include "brlcad/cicommon.h"
#include "brlcad/ConstDatabase.h"
#include <QPixmap>


class Camera {
public:
	Camera();
	double rotation;
	double *position;
	double *size;
	double *direction;

private:
	double *getViewportTopLeftInWorldSpace();
};


// class Callback: public BRLCAD::ConstDatabase::HitCallback {
// public:
// 	double red;
// 	double green;
// 	double blue;
// 	virtual bool operator()(const Hit& hit) throw() = 0;

// private:

// };


namespace DisplayUtils {
	QPixmap *rayTrace(BRLCAD::ConstDatabase *, const char *, Camera *);
	double *mapTo2D(BRLCAD::Vector3D *, Camera *);
	BRLCAD::Vector3D *mapTo3D(double *, Camera *);
};